/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv168.webapp;

import cz.muni.fi.pv168.webapp.entities.Food;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.activity.InvalidActivityException;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author bar
 */
@WebServlet(name = "FoodServlet", urlPatterns = {"/FoodServlet"})
public class FoodServlet extends HttpServlet {
    private List<Food> foods;
    

    @Override
    public void init()
    {
        foods = new ArrayList<>();
    }
    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP
     * <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        throw new InvalidActivityException("Post method is supported only!");
    }

    /**
     * Handles the HTTP
     * <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
            String foodname=request.getParameter("foodname");
            String strPrice = request.getParameter("price");
            if(!checkParams(foodname,strPrice))
            {
                request.setAttribute("error", "Nutno zadat obě pole!");
                request.getRequestDispatcher("/index.jsp").forward(request, response);
                return;
            }
            int price;
            try{
                price = Integer.parseInt(strPrice);
            }catch(NumberFormatException nfe){
                Logger.getAnonymousLogger(FoodServlet.class.getName()).log(Level.SEVERE,"Price is not an integer",nfe);
                request.setAttribute("error","Cena musi byt cele cislo!");
                request.getRequestDispatcher("/index.jsp").forward(request,response);
                return;
            }   
            Food food = new Food();
            food.setName(foodname);
            food.setPrice(price);
            foods.add(food);
            request.setAttribute("foods", foods);
            request.getRequestDispatcher("/list.jsp").forward(request,response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

    private boolean checkParams(String name, String price) {
        return name != null && price != null;
    }
}
